searchNodes=[{"ref":"LDAPEx.html","title":"LDAPEx","type":"module","doc":"Application and main interface to using LDAPEx"},{"ref":"LDAPEx.html#start/2","title":"LDAPEx.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"LDAPEx.Client.html","title":"LDAPEx.Client","type":"module","doc":"This handles the LDAP communications over the TCP or SSL connections."},{"ref":"LDAPEx.Client.html#child_spec/1","title":"LDAPEx.Client.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"LDAPEx.Client.html#close/1","title":"LDAPEx.Client.close/1","type":"function","doc":"\b\bThis will close the supplied LDAPEx.Client. iex&gt; {:ok, ldap} = LDAPEx.Client.start_link() iex&gt; is_pid(ldap) true iex&gt; LDAPEx.Client.close(ldap) :ok"},{"ref":"LDAPEx.Client.html#get_object/4","title":"LDAPEx.Client.get_object/4","type":"function","doc":"\b\bThis returns an object by a full object name, optionally can specify specific attributes to return, otherwise it returns all. This function ignores references and will only return a single full object result. If more than one object matched then the dn was not precise enough and it will return an {:error, reason} 2-tuple. iex&gt; {:ok, ldap} = LDAPEx.Client.start_link() iex&gt; {:ok, obj} = LDAPEx.Client.get_object(ldap, System.get_env(&quot;TEST_LDAP_DN&quot;)) iex&gt; obj.objectName === System.get_env(&quot;TEST_LDAP_DN&quot;) true iex&gt; map_size(obj.attributes) &gt;= 1 true iex&gt; LDAPEx.Client.close(ldap) :ok"},{"ref":"LDAPEx.Client.html#init/1","title":"LDAPEx.Client.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"LDAPEx.Client.html#search/4","title":"LDAPEx.Client.search/4","type":"function","doc":"\b\bThis performs a search in the LDAP connection using the record created by LDAPEx.Client.setup_search/1. iex&gt; {:ok, ldap} = LDAPEx.Client.start_link() iex&gt; req = LDAPEx.Client.setup_search(baseObject: System.get_env(&quot;TEST_LDAP_DN&quot;), filter: {:present, &quot;objectClass&quot;} ) iex&gt; {:ok, {res, _references}} = LDAPEx.Client.search(ldap, req) # _refs are just an empty [] in every server tested so far... iex&gt; [r] = res # Assuming only one record is returned iex&gt; r.objectName === System.get_env(&quot;TEST_LDAP_DN&quot;) true iex&gt; map_size(r.attributes) &gt;= 1 true iex&gt; LDAPEx.Client.close(ldap) :ok"},{"ref":"LDAPEx.Client.html#setup_search/1","title":"LDAPEx.Client.setup_search/1","type":"function","doc":"\b\bThis sets up a search record, this should then be passed into LDAPEx.Client.search/3 to perform the search. The :baseObject and :filter options are the minimum necessary to be supplied. Details on the LDAP Searching spec can be found at the LDAP Website - The Search Operation Details about LDAP Filters can be found at the LDAP Website - Filters. All possible options are: :baseObject -&gt; Specifies the base DN for the search. Only entries at or below this location in the server (based on the scope) will be considered potential matches. :scope -&gt; Specifies the range of entries relative to the base DN that may be considered potential matches. By default it is :wholeSubtree, which can be slow for many operations. Can also be set to the atoms :singleLevel or :baseObject. :derefAliases -&gt; Specifies the behavior that the server should exhibit if any alias entries are encountered while processing the search. This should generally always be left at its default atom of :derefAlways, however its other options are the atoms of :derefFindingBaseObj, :derefInSearching, and :neverDerefAliases. :sizeLimit -&gt; An integer that specifies the maximum number of entries that should be returned from the search. A value of zero indicates that there should not be any limit enforced. Note that the directory server may also be configured with a server-side size limit which can also limit the number of entries that may be returned to the client and in that case the smaller of the client-side and server-side limits will be used. If no size limit is provided, then a default of zero (unlimited) will be used. :timeLimit -&gt; Specifies the maximum length of time in seconds that the server should spend processing the search. A value of zero indicates that there should not be any limit enforced. Note that the directory server may also be configured with a server-side time limit which can also limit the processing time, and in that case the smaller of the client-side and server-side limits will be used. If no time limit is provided, then a default of the initial connection timeout value will be used. :typesOnly -&gt; Indicates whether matching entries should include only attribute names, or both attribute names and values. If no value is provided, then a default of false will be used. Other option is true. If it is true then the attribute values will just be the empty list []. :filter -&gt; A filter is a 2-tuple of one of the following: {:and, [&lt;AnotherFilter&gt;]} -&gt; And takes a list of other filters and requires them all. {:or, [&lt;AnotherFilter&gt;]} -&gt; Or takes a list of other filters and requires them all. {:not, &lt;AnotherFilter} -&gt; Not will invert another Filter. {:equalityMatch, {:AttributeValueAssertion, &quot;&lt;AttributeKey&gt;&quot;, &quot;&lt;AttributeValue&gt;&quot;}} -&gt; Equality Match takes an attribute key string and an attribute value string then filters on if the value matches the attribute value on the object. {:substrings, {:SubstringFilter, &quot;&lt;AttributeKey&gt;&quot;, [&lt;SubstringMatcher&gt;]}} -&gt; Substring takes an Attribute Key string, and a list of SubstringMaterchers, which are a 2-tuple of {:initial|:any|:final, &quot;&lt;String&gt;&quot;}. {:greaterOrEqual, {:AttributeValueAssertion, &quot;&lt;AttributeKey&gt;&quot;, &quot;&lt;AttributeValue&quot;}} -&gt; GreaterOrEqual takes an attribute key string and an attribute value string then filters on if the value is greater or equal to the attribute value on the object. {:lessOrEqual, {:AttributeValueAssertion, &quot;&lt;AttributeKey&gt;&quot;, &quot;&lt;AttributeValue&gt;&quot;}} -&gt; LessOrEqual takes an attribute key string and an attribute value string then filters on if the value is less or equal to the attribute value on the object. {:present, &quot;&quot;} -&gt; Present takes a single string and will match to an object if it contains that Attribute Key at all, or filters it out if it does not have that Attribute key. {:approxMatch, {:AttributeValueAssertion, &quot;&lt;AttributeKey&gt;&quot;, &quot;&lt;AttributeValue&gt;&quot;}} -&gt; ApproxMatch takes an attribute key string and an attribute value string then filters on if the value is approximately to the attribute value on the object. By &#39;approximately&#39; this means that the implementation is entirely defined by and dependent on the server. It might be phonetic, so something like &#39;John&#39; could match &#39;Jon&#39;, or it could be a LIKE type thing so &quot;Joh*&quot; could match &quot;John&quot; or &quot;Johnny&quot; or whatever it is the server wants to do. {:extensibleMatch, {:MatchingRuleAssertion, matchingRule = :asn1_NOVALUE, type = :asn1_NOVALUE, matchValue, dnAttributes = :asn1_DEFAULT}} -&gt; The Extensible Match is the most complex, but also the most powerful matcher that LDAP has to offer. Please see the &quot;Extensible Match Filters&quot; section on the above LDAP Filters link for details. &#39;matchingRule&#39;, &#39;type&#39;, and &#39;matchValue&#39; are all strings, and &#39;dnAttributes&#39; is a boolean. &#39;matchValue&#39; is the only required field, the rest may be left at the defaults that are listed above to have the server ignore those fields. The atom :asn1_DEFAULT on dnAttributes is equal to false. :attributes -&gt; A list of strings, default [], will return only the specified attributes, if empty it returns all. iex&gt; LDAPEx.Client.setup_search(baseObject: &quot;ou=People,o=example.com,o=cp&quot;, filter: {:present, &quot;dn&quot;} ) {:SearchRequest, &quot;ou=People,o=example.com,o=cp&quot;, :wholeSubtree, :derefAlways, 0, :undefined, false, {:present, &quot;dn&quot;}, []}"},{"ref":"LDAPEx.Client.html#start_link/1","title":"LDAPEx.Client.start_link/1","type":"function","doc":"\b\bCall this to start the client and link it to your process so it will be cleaned when your process exits, it will return {:ok, pid}. Any of the default config options can (and should be if not specified in the config) be specified here as a keyword list. iex&gt; {:ok, ldap} = LDAPEx.Client.start_link() iex&gt; is_pid(ldap) true # Anon login iex&gt; {:ok, ldap} = LDAPEx.Client.start_link(username: &quot;&quot;, password: &quot;&quot;) iex&gt; is_pid(ldap) true iex&gt; LDAPEx.Client.start_link(username: &quot;INVALID&quot;, password: &quot;&quot;) {:error, :invalidDNSyntax} iex&gt; LDAPEx.Client.start_link(username: System.get_env(&quot;TEST_LDAP_DN&quot;), password: &quot;INCORRECT&quot;) {:error, :invalidCredentials}"},{"ref":"LDAPEx.Client.LDAPException.html","title":"LDAPEx.Client.LDAPException","type":"exception","doc":""},{"ref":"LDAPEx.Config.html","title":"LDAPEx.Config","type":"module","doc":"This module handles reading in the default config from the environment while also combining those with any passed-in overrides."},{"ref":"LDAPEx.Config.html#get_config/0","title":"LDAPEx.Config.get_config/0","type":"function","doc":"Returns the environment default configuration map Examples iex&gt; vals = LDAPEx.Config.get_config() iex&gt; is_map(vals) true"},{"ref":"LDAPEx.Config.html#get_config/1","title":"LDAPEx.Config.get_config/1","type":"function","doc":"Returns the environment default configuration map with overrides specified Examples iex&gt; vals = LDAPEx.Config.get_config(server: &quot;127.0.0.1&quot;) iex&gt; is_map(vals) true iex&gt; vals.server &quot;127.0.0.1&quot; iex&gt; vals = LDAPEx.Config.get_config(%{server: &quot;127.0.0.1&quot;}) iex&gt; is_map(vals) true iex&gt; vals.server &quot;127.0.0.1&quot;"},{"ref":"LDAPEx.ELDAPv3.html","title":"LDAPEx.ELDAPv3","type":"module","doc":"\b\bThis is the module to the Erlang generated LDAP interfaces from the LDAP ASN1 file. The macros are records. LDAPEx.ELDAPv3.encode/2 and LDAPEx.ELDAPv3.decode/2 call into the erlang generated encode and decode functions. Everything is set up to take binaries instead of char_lists."},{"ref":"LDAPEx.ELDAPv3.html#AddRequest/1","title":"LDAPEx.ELDAPv3.AddRequest/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#AddRequest/2","title":"LDAPEx.ELDAPv3.AddRequest/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#AttributeValueAssertion/1","title":"LDAPEx.ELDAPv3.AttributeValueAssertion/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#AttributeValueAssertion/2","title":"LDAPEx.ELDAPv3.AttributeValueAssertion/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#BindRequest/1","title":"LDAPEx.ELDAPv3.BindRequest/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#BindRequest/2","title":"LDAPEx.ELDAPv3.BindRequest/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#BindResponse/1","title":"LDAPEx.ELDAPv3.BindResponse/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#BindResponse/2","title":"LDAPEx.ELDAPv3.BindResponse/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#CompareRequest/1","title":"LDAPEx.ELDAPv3.CompareRequest/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#CompareRequest/2","title":"LDAPEx.ELDAPv3.CompareRequest/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#Control/1","title":"LDAPEx.ELDAPv3.Control/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#Control/2","title":"LDAPEx.ELDAPv3.Control/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#ExtendedRequest/1","title":"LDAPEx.ELDAPv3.ExtendedRequest/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#ExtendedRequest/2","title":"LDAPEx.ELDAPv3.ExtendedRequest/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#ExtendedResponse/1","title":"LDAPEx.ELDAPv3.ExtendedResponse/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#ExtendedResponse/2","title":"LDAPEx.ELDAPv3.ExtendedResponse/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#IntermediateResponse/1","title":"LDAPEx.ELDAPv3.IntermediateResponse/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#IntermediateResponse/2","title":"LDAPEx.ELDAPv3.IntermediateResponse/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#LDAPMessage/1","title":"LDAPEx.ELDAPv3.LDAPMessage/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#LDAPMessage/2","title":"LDAPEx.ELDAPv3.LDAPMessage/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#LDAPResult/1","title":"LDAPEx.ELDAPv3.LDAPResult/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#LDAPResult/2","title":"LDAPEx.ELDAPv3.LDAPResult/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#MatchingRuleAssertion/1","title":"LDAPEx.ELDAPv3.MatchingRuleAssertion/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#MatchingRuleAssertion/2","title":"LDAPEx.ELDAPv3.MatchingRuleAssertion/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#ModifyDNRequest/1","title":"LDAPEx.ELDAPv3.ModifyDNRequest/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#ModifyDNRequest/2","title":"LDAPEx.ELDAPv3.ModifyDNRequest/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#ModifyRequest/1","title":"LDAPEx.ELDAPv3.ModifyRequest/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#ModifyRequest/2","title":"LDAPEx.ELDAPv3.ModifyRequest/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#ModifyRequest_changes_SEQOF/1","title":"LDAPEx.ELDAPv3.ModifyRequest_changes_SEQOF/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#ModifyRequest_changes_SEQOF/2","title":"LDAPEx.ELDAPv3.ModifyRequest_changes_SEQOF/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#PartialAttribute/1","title":"LDAPEx.ELDAPv3.PartialAttribute/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#PartialAttribute/2","title":"LDAPEx.ELDAPv3.PartialAttribute/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#SaslCredentials/1","title":"LDAPEx.ELDAPv3.SaslCredentials/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#SaslCredentials/2","title":"LDAPEx.ELDAPv3.SaslCredentials/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#SearchRequest/1","title":"LDAPEx.ELDAPv3.SearchRequest/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#SearchRequest/2","title":"LDAPEx.ELDAPv3.SearchRequest/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#SearchResultEntry/1","title":"LDAPEx.ELDAPv3.SearchResultEntry/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#SearchResultEntry/2","title":"LDAPEx.ELDAPv3.SearchResultEntry/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#SubstringFilter/1","title":"LDAPEx.ELDAPv3.SubstringFilter/1","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#SubstringFilter/2","title":"LDAPEx.ELDAPv3.SubstringFilter/2","type":"macro","doc":""},{"ref":"LDAPEx.ELDAPv3.html#decode/2","title":"LDAPEx.ELDAPv3.decode/2","type":"function","doc":""},{"ref":"LDAPEx.ELDAPv3.html#encode/2","title":"LDAPEx.ELDAPv3.encode/2","type":"function","doc":""},{"ref":"readme.html","title":"Getting Started","type":"extras","doc":"LDAPEx This is a fairly direct port of the Erlang :eldap module to Elixir, but using pure strings/binaries instead of char_lists like :eldap does. Will add additional features and modules over time."},{"ref":"readme.html#installation","title":"Getting Started - Installation","type":"extras","doc":"Available in Hex, the package can be installed by: Add :ldap_ex to your list of dependencies in mix.exs: def deps do [{:ldap_ex, &quot;~&gt; 0.2.2&quot;}] end 2. If you want defaults (highly recommended) for any unspecified value, add something like this to your configuration: ```elixir config :ldap_ex, :defaults, %{ server: System.get_env(&quot;LDAP_SERVER&quot;), port: elem(Integer.parse(System.get_env(&quot;LDAP_PORT&quot;)), 0), ssl: System.get_env(&quot;LDAP_SSL&quot;) == &quot;true&quot;, username: System.get_env(&quot;LDAP_USERNAME&quot;), password: System.get_env(&quot;LDAP_PASSWORD&quot;), timeout: 5000 } See the API Reference for usage. For using the client see the Client API Reference."},{"ref":"readme.html#features","title":"Getting Started - Features","type":"extras","doc":"Thus far this is good for reading from LDAP, it has no writing functionality as of yet, though it should be fairly simple to add now that the complex handling is complete. Pull Requests are welcome and encouraged. As of right now it is mostly feature-complete for what I am needing, however I may add a DSEL, perhaps ecto-like for the complex search request record. May eventually add a LDAPEx.Ecto adapter for integration with ecto2. Of course if anyone wants to add any of these wanted features or anything else useful then please submit Pull Requests."}]